/*
 * Copyright (c) 2007-2008 Sun Microsystems, Inc.  All rights reserved.
 *
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

BEGIN
{
    recvs_bytes=0;
    recvs_act=0;
    recvs_posted_size=0;
    recvs_unexp_size=0;
    recvs_posted_matches=0;
    recvs_unexp_matches=0;

    sends_act=0;
    sends_bytes=0;
    output_cnt = 0;
    printf("input(Total) Q-sizes      Q-Matches            output\n");
    printf("bytes active posted unexp posted unexp         bytes active\n");
    printf("%5d %6d %6d %5d %6d %5d      %5d %6d \n", 
           recvs_bytes, recvs_act, recvs_posted_size, recvs_unexp_size,
           recvs_posted_matches, recvs_unexp_matches,
           sends_bytes, sends_act);
}
/* Print Statistics every 1 sec */
profile:::tick-1sec
{
    printf("%5d %6d %6d %5d %6d %5d      %5d %6d \n", 
           recvs_bytes, recvs_act, recvs_posted_size, recvs_unexp_size,
           recvs_posted_matches, recvs_unexp_matches,
           sends_bytes, sends_act);
    ++output_cnt;
}
profile:::tick-1sec
/output_cnt==22/
{
    printf("input(Total) Q-sizes      Q-Matches            output\n");
    printf("bytes active posted unexp posted unexp         bytes active\n");
    printf("%5d %6d %6d %5d %6d %5d      %5d %6d \n", 
           recvs_bytes, recvs_act, recvs_posted_size, recvs_unexp_size,
           recvs_posted_matches, recvs_unexp_matches,
           sends_bytes, sends_act);
    output_cnt=0;
}


/* Collect Send statistics */
/* Collect Active Send Requests */
mpiperuse$target:::comm-req-activate
/args[3]->mcs_op=="send"/
{
   ++sends_act;
}

/* Collect Removal of Send Requests */
mpiperuse$target:::comm-req-notify
/args[3]->mcs_op=="send"/
{
   --sends_act;
}

/* Collect bytes Sent */
mpiperuse$target:::comm-req-xfer-end
/args[3]->mcs_op=="send"/
{
   sends_bytes += args[3]->mcs_count;
}

/* Collect Active Recv Request */
mpiperuse$target:::comm-req-activate
/args[3]->mcs_op=="recv"/
{
   ++recvs_act;
}

/* Collect Removal of Recv Request */
mpiperuse$target:::comm-req-notify
/args[3]->mcs_op=="recv"&&recvs_act>0/
{
   --recvs_act;
}

/* Collect Request Placed on Posted Q */
mpiperuse$target:::comm-req-insert-in-posted-q
/args[3]->mcs_op=="recv"/
{
   ++recvs_posted_size;
}

/* Collect Msg matched Posted Q */
mpiperuse$target:::comm-msg-match-posted-req
/args[3]->mcs_op=="recv"/
{
   ++recvs_posted_matches;
}
mpiperuse$target:::comm-msg-match-posted-req
/args[3]->mcs_op=="recv"&&recvs_posted_size>0/
{
   --recvs_posted_size;
}

/* Collect messages in unexp Q */
mpiperuse$target:::comm-msg-insert-in-unex-q
/args[3]->mcs_op=="recv"/
{
   ++recvs_unexp_size;
}

/* Collect messages removed from unexp Q */
mpiperuse$target:::comm-msg-remove-from-unex-q
/args[3]->mcs_op=="recv"&&recvs_unexp_size>0/
{
   --recvs_unexp_size;
}

/* Collect messages removed from unexp Q */
mpiperuse$target:::comm-req-match-unex
/args[3]->mcs_op=="recv"/
{
   ++recvs_unexp_matches;
}

/* Collect bytes being recieved */
mpiperuse$target:::comm-req-xfer-continue
/args[3]->mcs_op=="recv"/
{
   recvs_bytes += args[3]->mcs_count;
}

END
{
}

